#define GLSLIFY 1

float u_time = 1;
//float offset = 0.5;
vec2 u_mouse = vec2(500.,300.);
uniform float size;

// Texture uniforms
uniform sampler2D u_texture;

// Texture varyings
varying vec4 texCoordOut;

void main() {
    // Calculate the pixel color based on the mouse position
    vec3 pixel_color = vec3(0,0,0);

    if (gl_FragCoord.x > u_mouse.x) {
        // Apply the gaussian kernel
        float step = 1.0 + 2.0 * u_mouse.y / size;
        pixel_color += (1.0 / 256.0) * texture2D(u_texture, texCoordOut.xy + step * vec2(-2, -2) / size).rgb;
        pixel_color += (4.0 / 256.0) * texture2D(u_texture, texCoordOut.xy + step * vec2(-2, -1) / size).rgb;
        pixel_color += (6.0 / 256.0) * texture2D(u_texture, texCoordOut.xy + step * vec2(-2, 0) / size).rgb;
        pixel_color += (4.0 / 256.0) * texture2D(u_texture, texCoordOut.xy + step * vec2(-2, 1) / size).rgb;
        pixel_color += (1.0 / 256.0) * texture2D(u_texture, texCoordOut.xy + step * vec2(-2, 2) / size).rgb;
        pixel_color += (4.0 / 256.0) * texture2D(u_texture, texCoordOut.xy + step * vec2(-1, -2) / size).rgb;
        pixel_color += (16.0 / 256.0) * texture2D(u_texture, texCoordOut.xy + step * vec2(-1, -1) / size).rgb;
        pixel_color += (24.0 / 256.0) * texture2D(u_texture, texCoordOut.xy + step * vec2(-1, 0) / size).rgb;
        pixel_color += (16.0 / 256.0) * texture2D(u_texture, texCoordOut.xy + step * vec2(-1, 1) / size).rgb;
        pixel_color += (4.0 / 256.0) * texture2D(u_texture, texCoordOut.xy + step * vec2(-1, 2) / size).rgb;
        pixel_color += (6.0 / 256.0) * texture2D(u_texture, texCoordOut.xy + step * vec2(0, -2) / size).rgb;
        pixel_color += (24.0 / 256.0) * texture2D(u_texture, texCoordOut.xy + step * vec2(0, -1) / size).rgb;
        pixel_color += (36.0 / 256.0) * texture2D(u_texture, texCoordOut.xy + step * vec2(0, 0) / size).rgb;
        pixel_color += (24.0 / 256.0) * texture2D(u_texture, texCoordOut.xy + step * vec2(0, 1) / size).rgb;
        pixel_color += (6.0 / 256.0) * texture2D(u_texture, texCoordOut.xy + step * vec2(0, 2) / size).rgb;
        pixel_color += (4.0 / 256.0) * texture2D(u_texture, texCoordOut.xy + step * vec2(1, -2) / size).rgb;
        pixel_color += (16.0 / 256.0) * texture2D(u_texture, texCoordOut.xy + step * vec2(1, -1) / size).rgb;
        pixel_color += (24.0 / 256.0) * texture2D(u_texture, texCoordOut.xy + step * vec2(1, 0) / size).rgb;
        pixel_color += (16.0 / 256.0) * texture2D(u_texture, texCoordOut.xy + step * vec2(1, 1) / size).rgb;
        pixel_color += (4.0 / 256.0) * texture2D(u_texture, texCoordOut.xy + step * vec2(1, 2) / size).rgb;
        pixel_color += (1.0 / 256.0) * texture2D(u_texture, texCoordOut.xy + step * vec2(2, -2) / size).rgb;
        pixel_color += (4.0 / 256.0) * texture2D(u_texture, texCoordOut.xy + step * vec2(2, -1) / size).rgb;
        pixel_color += (6.0 / 256.0) * texture2D(u_texture, texCoordOut.xy + step * vec2(2, 0) / size).rgb;
        pixel_color += (4.0 / 256.0) * texture2D(u_texture, texCoordOut.xy + step * vec2(2, 1) / size).rgb;
        pixel_color += (1.0 / 256.0) * texture2D(u_texture, texCoordOut.xy + step * vec2(2, 2) / size).rgb;
    } else if (gl_FragCoord.x > u_mouse.x - 1.0) {
        // Draw a line indicating the transition
        pixel_color = vec3(0.0);
    } else {
        // Use the original image pixel color
        pixel_color = texture2D(u_texture, texCoordOut.xy).rgb;
    }

// Fragment shader output
    gl_FragColor = vec4(pixel_color, 1.0);
}
