
// fragment shader

#version 330

#ifdef GL_ES
// Set default precision to medium
precision mediump float;
#endif

const float tau = 6.2832;

uniform float time;
uniform vec2 resolution;
out vec4 glFragColor;

void main(void) {
  vec2 uv = (2.0 * gl_FragCoord.xy - resolution) / min(resolution.x, resolution.y);
  float v = cos(0.1 * uv.x * tau + sin(uv.y + time * 0.90));
  v += cos(.10 * tau * uv.y + sin(uv.x + time * 1.6));
  v += sin(length(uv));
  v *= 0.125;
  v += (time * 0.1);
  vec3 c = vec3(0.5) + 0.9 * cos(tau * (v + vec3(0.2, 0.4, 0.8)));
  glFragColor = vec4(vec3(c), 1.0);
}
