
// fragment shader

#version 330

#ifdef GL_ES
// Set default precision to medium
precision mediump float;
#endif

const float tau = 6.2832;

uniform float time;
uniform vec2 resolution;
out vec4 glFragColor;

void main(void) {
  vec2 uv = (2.0 * gl_FragCoord.xy - resolution) / min(resolution.x, resolution.y);
  float v = cos(tau * uv.x + sin(uv.y *2.0 + time));
  v += cos(tau * uv.y + sin(uv.x *2.0 + time*0.1));
  v+=sin(length(uv));
  v*=0.125;
  v+=0.125;
  v+=time*0.01;

  vec3 c = vec3(0.5) + 0.5 * cos(tau * (v + vec3(cos(time*0.1), 0.1, 0.3)));
  glFragColor = vec4(c, 1.0);
}
