
// fragment shader

#version 330

#ifdef GL_ES
// Set default precision to medium
precision mediump float;
#endif

uniform float time;
uniform vec2 resolution;

const float tau = 6.2832;

vec3 plasma(vec2 uv){
  float v = tan(tau * uv.x + sin(uv.y * 3.0 + time));

  vec3 rgb = vec3(vec2(0.7, 1.0) * time, 0.5);
  v += cos(tau * uv.y + sin(uv.x + time * 1.6));
  v *= 0.25;
  v += 0.5;
  v += time * 0.7;
  return vec3(0.5) + 0.1 * cos(tau * (v + rgb));
}




void main(void) {
  vec2 uv = (2.0 * gl_FragCoord.xy - resolution) / min(resolution.x, resolution.y);
  gl_FragColor = vec4(plasma(uv), 1.0);
}
